#!/bin/sed -f
#
# Script to generate config_spam_rule.h from config_spam_rule.in
#
# config_spam_rule.in format:
# format:
#	type name default (depends,...) # comment
# eg:
#bool spam_check 0 () #doesn't depend
#bool smtp_checks 1 (spam_check) #depends on spam check
#bool smtp_block 1 (smtp_check) #depends both spam and smtp check
#
# See LICENSCE for use and copying information.
#
# type name default <desc> # comment
#

#
# File header and structure start
#
1{
a \
/************************************************************/ \
/* This file has been automatically generated. DO NOT EDIT! */ \
/*                                                          */ \
/* See the file LICENCE for use and copying information.    */ \
/************************************************************/ \
\
\#include <liblm.h> \
\
\#include "strlist.h" \
\#ifndef _CONFIG_SPAM_RULE_H \
\#define _CONFIG_SPAM_RULE_H \
\
typedef struct tag_config_spam_rule_t \
\{
}

#
# Footer: structure close and function declerations.
#
${
a \
\} config_spam_rule_t;\
\
int config_spam_rule_load(lm_string_t addr, \
		config_spam_rule_t *ruledata, lm_string_t dotspam); \
int config_spam_rule_free(config_spam_rule_t *ruledata); \
int config_spam_rule_read(config_spam_rule_t* globalrules, config_spam_rule_t *ruledata);\
\
extern config_spam_rule_t global_spam_rules; \
\
\#endif 
}

#
# Clean the input file 
#
{
# Strip comments and end of line whitespace
s/[[:space:]]*\#.*$//
# Strip beginning of line whitespace 
s/^[[:space:]]*//
# delete blank lines
/^$/d
}

#
# Generate the output lines
#
/^$/!{ # don't bother with blanks
# save the orginal string and create the variable definition 
h
s/^bool[[:space:]]\+\([[:alnum:]_]\+\).*/lm_config_bool_t \1;/p
s/^string[[:space:]]\+\([[:alnum:]_]\+\).*/lm_config_string_t \1;/p
s/^strlist[[:space:]]\+\([[:alnum:]_]\+\).*/strlist_t \1;/p

# get the string and uppercase
g;y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/
# create the default value define using the name of the variable and the given default 
s/^\([[:alnum:]]\+\)[[:space:]]\+\([[:alnum:]_]\+\)[[:space:]]\+\([^[:space:]]\+\)\(.*\)/\#define SPAM_CONTROL_\2_DEFAULT \3/p

# get orignal and create the control key name
g;s/^\([[:alnum:]]\+\)[[:space:]]\+\([[:alnum:]_]\+\)[[:space:]]\+\([^[:space:]]\+\)\(.*\)/\2/
# save and uppercase 
h; y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/
# put the define with a line continuation
s/.*/\#define SPAM_CONTROL_& \\/p
# get lowercase version put on the next line surrounded by quotes 
g;s/.*/"&"/
# newline
a \

}
